scala.collection

# GenIterable

###
Related Docs: object GenIterable | package collection

#### trait GenIterable[+A] extends GenIterableLike[A, GenIterable[A]] with GenTraversable[A] with GenericTraversableTemplate[A, GenIterable]

A trait for all iterable collections which may possibly have their operations implemented in parallel.

Source
  GenIterable.scala
Since

  2.9

Linear Supertypes
GenTraversable[A], GenericTraversableTemplate[A, GenIterable], HasNewBuilder[A, scala.collection.GenIterable[A] @scala.annotation.unchecked.uncheckedVariance], GenIterableLike[A, GenIterable[A]], GenTraversableLike[A, GenIterable[A]], Parallelizable[A, ParIterable[A]], GenTraversableOnce[A], AnyRef, Any
Known Subclasses
::, AbstractBuffer, AbstractIterable, AbstractIterable, AbstractMap, AbstractMap, AbstractMap, AbstractSeq, AbstractSeq, AbstractSet, AbstractSet, AnyRefMap, Appended, Appended, Appended, ArrayBuffer, ArraySeq, ArrayStack, BitSet, BitSet, BitSet, BitSet1, BitSet2, BitSetN, Buffer, BufferProxy, Cons, DefaultKeySet, DefaultKeySet, DefaultKeySet, DefaultKeySortedSet, DefaultKeySortedSet, DefaultMap, DefaultMap, DefaultMapModel, DefaultValuesIterable, DefaultValuesIterable, DoubleLinkedList, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, Empty, EmptyView, EmptyView, EmptyView, Exclusive, Filtered, Filtered, Filtered, Filtered, FilteredKeys, FilteredKeys, FlatMapped, FlatMapped, FlatMapped, Forced, Forced, Forced, GenMap, GenSeq, GenSet, HashMap, HashMap, HashMap1, HashSet, HashSet, HashTrieMap, HashTrieSet, History, ImmutableDefaultKeySet, ImmutableMapAdaptor, ImmutableSetAdaptor, Impl, Inclusive, Inclusive, IndexedSeq, IndexedSeq, IndexedSeq, IndexedSeqView, IntMap, Iterable, Iterable, Iterable, IterableForwarder, IterableProxy, IterableView, IterableViewLike, LinearSeq, LinearSeq, LinearSeq, LinkedHashMap, LinkedHashSet, LinkedList, List, ListBuffer, ListMap, ListMap, ListSet, LongMap, LongMap, Map, Map, Map, Map, Map1, Map2, Map3, Map4, MapProxy, MapProxy, MapProxy, Mapped, Mapped, Mapped, MappedValues, MappedValues, MultiMap, MutableList, Nil, Node, Node, NumericRange, ObservableBuffer, ObservableMap, ObservableSet, OpenHashMap, PagedSeq, ParArray, ParHashMap, ParHashMap, ParHashSet, ParHashSet, ParIterable, ParIterable, ParIterable, ParMap, ParMap, ParMap, ParRange, ParSeq, ParSeq, ParSeq, ParSet, ParSet, ParSet, ParTrieMap, ParVector, Patched, Patched, Prepended, Prepended, PriorityQueue, PriorityQueueProxy, Queue, Queue, QueueProxy, Range, ResizableArray, Reversed, Reversed, Reversed, RevertibleHistory, Script, Seq, Seq, Seq, SeqForwarder, SeqProxy, SeqView, SeqViewLike, Set, Set, Set, Set1, Set2, Set3, Set4, SetProxy, SetProxy, SetProxy, Sliced, Sliced, Sliced, Sliced, SortedMap, SortedMap, SortedSet, SortedSet, SortedSet, Stack, Stack, StackProxy, Stream, StreamView, StreamViewLike, StringBuilder, SynchronizedBuffer, SynchronizedMap, SynchronizedPriorityQueue, SynchronizedQueue, SynchronizedSet, SynchronizedStack, SystemProperties, TakenWhile, TakenWhile, TakenWhile, TakenWhile, Transformed, Transformed, Transformed, Transformed, TreeMap, TreeSet, TreeSet, TrieMap, UnrolledBuffer, ValueSet, Vector, WithDefault, WithDefault, WithDefault, WithDefault, WithDefault, WithDefault, WrappedArray, WrappedString, Zipped, Zipped, Zipped, ZippedAll, ZippedAll, ZippedAll, ofBoolean, ofByte, ofChar, ofDouble, ofFloat, ofInt, ofLong, ofRef, ofShort, ofUnit
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. GenIterable
2. GenTraversable
3. GenericTraversableTemplate
4. HasNewBuilder
5. GenIterableLike
6. GenTraversableLike
7. Parallelizable
8. GenTraversableOnce
9. AnyRef
10. Any

Implicitly

1. by CollectionsHaveToParArray
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (5 /: a)(_+_)
       b: Int = 15

       scala> val c = (5 /: a)((x,y) => x + y)
       c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

         op(...op(op(z, x_1), x_2), ..., x_n)

     where `x1, ..., xn` are the elements of this collection or iterator.

   Definition Classes
     GenTraversableOnce

2. #### abstract def :\[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

       scala> val a = List(1,2,3,4)
       a: List[Int] = List(1, 2, 3, 4)

       scala> val b = (a :\ 5)(_+_)
       b: Int = 15

       scala> val c = (a :\ 5)((x,y) => x + y)
       c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

         op(x_1, op(x_2, ... op(x_n, z)...))

     where `x1, ..., xn` are the elements of this collection or iterator.

   Definition Classes
     GenTraversableOnce

3. #### abstract def aggregate[B](z: ⇒ B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

   Aggregates the results of applying an operator to subsequent elements.

   Aggregates the results of applying an operator to subsequent elements.

   This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

   For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

       pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

   Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

   B

     the type of accumulated results

   z

     the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

   seqop

     an operator used to accumulate results within a partition

   combop

     an associative operator used to combine results from different partitions

   Definition Classes
     GenTraversableOnce

4. #### abstract def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

   Definition Classes
     GenTraversableOnce

5. #### abstract def count(p: (A) ⇒ Boolean): Int

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     the number of elements satisfying the predicate `p`.

   Definition Classes
     GenTraversableOnce

6. #### abstract def drop(n: Int): GenIterable[A]

   Selects all elements except first n ones.

   Selects all elements except first n ones.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   n

     the number of elements to drop from this general collection.

   returns

     a general collection consisting of all elements of this general collection except the first `n` ones, or else the empty general collection, if this general collection has less than `n` elements.

   Definition Classes
     GenTraversableLike

7. #### abstract def dropWhile(pred: (A) ⇒ Boolean): GenIterable[A]

   Drops longest prefix of elements that satisfy a predicate.

   Drops longest prefix of elements that satisfy a predicate.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   pred

     The predicate used to test elements.

   returns

     the longest suffix of this general collection whose first element does not satisfy the predicate `p`.

   Definition Classes
     GenTraversableLike

8. #### abstract def exists(pred: (A) ⇒ Boolean): Boolean

   Definition Classes
     GenTraversableOnce

9. #### abstract def filter(pred: (A) ⇒ Boolean): GenIterable[A]

   Selects all elements of this general collection which satisfy a predicate.

   Selects all elements of this general collection which satisfy a predicate.

   pred

     the predicate used to test elements.

   returns

     a new general collection consisting of all elements of this general collection that satisfy the given predicate `p`. Their order may not be preserved.

   Definition Classes
     GenTraversableLike

10. #### abstract def filterNot(pred: (A) ⇒ Boolean): GenIterable[A]

    Selects all elements of this general collection which do not satisfy a predicate.

    Selects all elements of this general collection which do not satisfy a predicate.

    pred

      the predicate used to test elements.

    returns

      a new general collection consisting of all elements of this general collection that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      GenTraversableLike

11. #### abstract def find(pred: (A) ⇒ Boolean): Option[A]

    Finds the first element of the collection or iterator satisfying a predicate, if any.

    Finds the first element of the collection or iterator satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pred

      the predicate used to test elements.

    returns

      an option value containing the first element in the collection or iterator that satisfies `p`, or `None` if none exists.

    Definition Classes
      GenTraversableOnce

12. #### abstract def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this collection or iterator using the specified associative binary operator.

    Folds the elements of this collection or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      GenTraversableOnce

13. #### abstract def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

14. #### abstract def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

15. #### abstract def forall(pred: (A) ⇒ Boolean): Boolean

    Definition Classes
      GenTraversableOnce

16. #### abstract def groupBy[K](f: (A) ⇒ K): GenMap[K, GenIterable[A]]

    Partitions this general collection into a map of general collections according to some discriminator function.

    Partitions this general collection into a map of general collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new general collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to general collections such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a general collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      GenTraversableLike

17. #### abstract def hasDefiniteSize: Boolean

    Definition Classes
      GenTraversableOnce

18. #### abstract def head: A

    Selects the first element of this collection.

    Selects the first element of this collection.

    returns

      the first element of this collection.

    Definition Classes
      GenericTraversableTemplate
    Exceptions thrown

      `NoSuchElementException` if the collection is empty.

19. #### abstract def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the first element of this general collection if it is nonempty, `None` if it is empty.

    Definition Classes
      GenTraversableLike

20. #### abstract def init: GenIterable[A]

    Selects all elements except the last.

    Selects all elements except the last.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a general collection consisting of all elements of this general collection except the last one.

    Definition Classes
      GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the general collection is empty.

21. #### abstract def isEmpty: Boolean

    Tests whether this collection is empty.

    Tests whether this collection is empty.

    returns

      `true` if the collection contain no elements, `false` otherwise.

    Definition Classes
      GenericTraversableTemplate

22. #### abstract def isTraversableAgain: Boolean

    Tests whether this general collection can be repeatedly traversed.

    Tests whether this general collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

23. #### abstract def iterator: Iterator[A]

    Definition Classes
      GenIterableLike

24. #### abstract def last: A

    Selects the last element.

    Selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      The last element of this general collection.

    Definition Classes
      GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the general collection is empty.

25. #### abstract def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      the last element of this general collection$ if it is nonempty, `None` if it is empty.

    Definition Classes
      GenTraversableLike

26. #### abstract def mkString: String

    Displays all elements of this collection or iterator in a string.

    Displays all elements of this collection or iterator in a string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator follow each other without any separator string.

    Definition Classes
      GenTraversableOnce

27. #### abstract def mkString(sep: String): String

    Displays all elements of this collection or iterator in a string using a separator string.

    Displays all elements of this collection or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Definition Classes
      GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

28. #### abstract def mkString(start: String, sep: String, end: String): String

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this collection or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Definition Classes
      GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

29. #### abstract def nonEmpty: Boolean

    Tests whether the collection or iterator is not empty.

    Tests whether the collection or iterator is not empty.

    returns

      `true` if the collection or iterator contains at least one element, `false` otherwise.

    Definition Classes
      GenTraversableOnce

30. #### abstract def parCombiner: Combiner[A, ParIterable[A]]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      Parallelizable

31. #### abstract def partition(pred: (A) ⇒ Boolean): (GenIterable[A], GenIterable[A])

    Partitions this general collection in two general collections according to a predicate.

    Partitions this general collection in two general collections according to a predicate.

    pred

      the predicate on which to partition.

    returns

      a pair of general collections: the first general collection consists of all elements that satisfy the predicate `p` and the second general collection consists of all elements that don't. The relative order of the elements in the resulting general collections may not be preserved.

    Definition Classes
      GenTraversableLike

32. #### abstract def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection or iterator is nonempty.

    Definition Classes
      GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this collection or iterator is empty.

33. #### abstract def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this collection or iterator is nonempty, `None` otherwise.

    Definition Classes
      GenTraversableOnce

34. #### abstract def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      GenTraversableOnce

35. #### abstract def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left:

          op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce
    Exceptions thrown

      `UnsupportedOperationException` if this collection or iterator is empty.

36. #### abstract def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this collection or iterator is nonempty, `None` otherwise.

    Definition Classes
      GenTraversableOnce

37. #### abstract def repr: GenIterable[A]

    Definition Classes
      GenTraversableLike

38. #### abstract def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[GenIterable[A], B, That]): That

    Computes a prefix scan of the elements of the collection.

    Computes a prefix scan of the elements of the collection.

    Note: The neutral element `z` may be applied more than once.

    B

      element type of the resulting collection

    That

      type of the resulting collection

    z

      neutral element for the operator `op`

    op

      the associative operator for the scan

    cbf

      combiner factory which provides a combiner

    returns

      a new general collection containing the prefix scan of the elements in this general collection

    Definition Classes
      GenTraversableLike

39. #### abstract def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[GenIterable[A], B, That]): That

    Produces a collection containing cumulative results of applying the operator going left to right.

    Produces a collection containing cumulative results of applying the operator going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    B

      the type of the elements in the resulting collection

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      collection with intermediate results

    Definition Classes
      GenTraversableLike

40. #### abstract def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[GenIterable[A], B, That]): That

    Produces a collection containing cumulative results of applying the operator going right to left.

    Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Example:

        List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

    B

      the type of the elements in the resulting collection

    That

      the actual type of the resulting collection

    z

      the initial value

    op

      the binary operator applied to the intermediate result and the element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      collection with intermediate results

    Definition Classes
      GenTraversableLike
    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

41. #### abstract def seq: Iterable[A]

    Definition Classes
      GenIterable → GenTraversable → Parallelizable → GenTraversableOnce

42. #### abstract def size: Int

    The size of this general collection.

    The size of this general collection.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this general collection.

    Definition Classes
      GenTraversableLike → GenTraversableOnce

43. #### abstract def slice(unc_from: Int, unc_until: Int): GenIterable[A]

    Selects an interval of elements.

    Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

        from <= indexOf(x) < until

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    unc_from

      the lowest index to include from this general collection.

    unc_until

      the lowest index to EXCLUDE from this general collection.

    returns

      a general collection containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this general collection.

    Definition Classes
      GenTraversableLike

44. #### abstract def span(pred: (A) ⇒ Boolean): (GenIterable[A], GenIterable[A])

    Splits this general collection into a prefix/suffix pair according to a predicate.

    Splits this general collection into a prefix/suffix pair according to a predicate.

    Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pred

      the test predicate

    returns

      a pair consisting of the longest prefix of this general collection whose elements all satisfy `p`, and the rest of this general collection.

    Definition Classes
      GenTraversableLike

45. #### abstract def splitAt(n: Int): (GenIterable[A], GenIterable[A])

    Splits this general collection into two at a given position.

    Splits this general collection into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the position at which to split.

    returns

      a pair of general collections consisting of the first `n` elements of this general collection, and the other elements.

    Definition Classes
      GenTraversableLike

46. #### abstract def stringPrefix: String

    Defines the prefix of this object's `toString` representation.

    Defines the prefix of this object's `toString` representation.

    returns

      a string representation which starts the result of `toString` applied to this general collection. By default the string prefix is the simple name of the collection class general collection.

    Definition Classes
      GenTraversableLike

47. #### abstract def tail: GenIterable[A]

    Selects all elements except the first.

    Selects all elements except the first.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      a general collection consisting of all elements of this general collection except the first one.

    Definition Classes
      GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the general collection is empty.

48. #### abstract def take(n: Int): GenIterable[A]

    Selects first n elements.

    Selects first n elements.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to take from this general collection.

    returns

      a general collection consisting only of the first `n` elements of this general collection, or else the whole general collection, if it has less than `n` elements.

    Definition Classes
      GenTraversableLike

49. #### abstract def takeWhile(pred: (A) ⇒ Boolean): GenIterable[A]

    Takes longest prefix of elements that satisfy a predicate.

    Takes longest prefix of elements that satisfy a predicate.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pred

      The predicate used to test elements.

    returns

      the longest prefix of this general collection whose elements all satisfy the predicate `p`.

    Definition Classes
      GenTraversableLike

50. #### abstract def toBuffer[A1 >: A]: Buffer[A1]

    Uses the contents of this collection or iterator to create a new mutable buffer.

    Uses the contents of this collection or iterator to create a new mutable buffer.

    Note: will not terminate for infinite-sized collections.

    returns

      a buffer containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

51. #### abstract def toIndexedSeq: immutable.IndexedSeq[A]

    Converts this collection or iterator to an indexed sequence.

    Converts this collection or iterator to an indexed sequence.

    Note: will not terminate for infinite-sized collections.

    returns

      an indexed sequence containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

52. #### abstract def toIterable: GenIterable[A]

    Converts this collection or iterator to an iterable collection.

    Converts this collection or iterator to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

    Note: will not terminate for infinite-sized collections.

    returns

      an `Iterable` containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

53. #### abstract def toIterator: Iterator[A]

    Returns an Iterator over the elements in this collection or iterator.

    Returns an Iterator over the elements in this collection or iterator. Will return the same Iterator if this instance is already an Iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      an Iterator containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

54. #### abstract def toList: List[A]

    Converts this collection or iterator to a list.

    Converts this collection or iterator to a list.

    Note: will not terminate for infinite-sized collections.

    returns

      a list containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

55. #### abstract def toSeq: GenSeq[A]

    Converts this collection or iterator to a sequence.

    Converts this collection or iterator to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

    Note: will not terminate for infinite-sized collections.

    returns

      a sequence containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

56. #### abstract def toSet[A1 >: A]: GenSet[A1]

    Converts this collection or iterator to a set.

    Converts this collection or iterator to a set.

    Note: will not terminate for infinite-sized collections.

    returns

      a set containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

57. #### abstract def toStream: Stream[A]

    Converts this collection or iterator to a stream.

    Converts this collection or iterator to a stream.

    returns

      a stream containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

58. #### abstract def toTraversable: GenTraversable[A]

    Converts this collection or iterator to an unspecified Traversable.

    Converts this collection or iterator to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

    Note: will not terminate for infinite-sized collections.

    returns

      a Traversable containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

59. #### abstract def toVector: Vector[A]

    Converts this collection or iterator to a Vector.

    Converts this collection or iterator to a Vector.

    Note: will not terminate for infinite-sized collections.

    returns

      a vector containing all elements of this collection or iterator.

    Definition Classes
      GenTraversableOnce

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from GenIterable[A] to any2stringadd[GenIterable[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### abstract def ++[B](that: GenTraversableOnce[B]): Traversable[B]

   [use case] Returns a new collection containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new collection containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the collection is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = List(1)
       a: List[Int] = List(1)

       scala> val b = List(2)
       b: List[Int] = List(2)

       scala> val c = a ++ b
       c: List[Int] = List(1, 2)

       scala> val d = List('a')
       d: List[Char] = List(a)

       scala> val e = c ++ d
       e: List[AnyVal] = List(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection which contains all elements of this collection followed by all elements of `that`.

   Definition Classes
     GenTraversableLike
   Full Signature

   #### abstract def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[GenIterable[A], B, That]): That

5. #### def ->[B](y: B): (GenIterable[A], B)

   Implicit information
     This member is added by an implicit conversion from GenIterable[A] to ArrowAssoc[GenIterable[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

9. #### abstract def collect[B](pf: PartialFunction[A, B]): Traversable[B]

   [use case] Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

   [use case]

   Builds a new collection by applying a partial function to all elements of this collection on which the function is defined.

   B

     the element type of the returned collection.

   pf

     the partial function which filters and maps the collection.

   returns

     a new collection resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

   Definition Classes
     GenTraversableLike
   Full Signature

   #### abstract def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[GenIterable[A], B, That]): That

10. #### def companion: GenericCompanion[GenIterable]

    The factory companion object that builds instances of class Traversable.

    The factory companion object that builds instances of class Traversable. (or its `Iterable` superclass where class Traversable is not a `Seq`.)

    Definition Classes
      GenIterable → GenTraversable → GenericTraversableTemplate

11. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this collection to an array.

    [use case]

    Copies values of this collection to an array. Fills the given array `xs` with values of this collection, beginning at index `start`. Copying will stop once either the end of the current collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def copyToArray[B >: A](xs: Array[B], start: Int): Unit

12. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this collection to an array.

    [use case]

    Copies values of this collection to an array. Fills the given array `xs` with values of this collection. Copying will stop once either the end of the current collection is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def copyToArray[B >: A](xs: Array[B]): Unit

13. #### def ensuring(cond: (GenIterable[A]) ⇒ Boolean, msg: ⇒ Any): GenIterable[A]

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to Ensuring[GenIterable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (GenIterable[A]) ⇒ Boolean): GenIterable[A]

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to Ensuring[GenIterable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): GenIterable[A]

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to Ensuring[GenIterable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): GenIterable[A]

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to Ensuring[GenIterable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

19. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

20. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): Traversable[B]

    [use case] Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this collection and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of collection. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection resulting from applying the given collection-valued function `f` to each element of this collection and concatenating the results.

    Definition Classes
      GenTraversableLike
    Full Signature

    #### abstract def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[GenIterable[A], B, That]): That

21. #### def flatten[B]: Traversable[B]

    [use case] Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    [use case]

    Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of collection. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(1, 2, 3)
                 ).flatten
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(
                   List(1, 2, 3),
                   List(3, 2, 1)
                 ).flatten
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new collection resulting from concatenating all element collections.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): GenIterable[B]

22. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case]

    [use case]
    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### abstract def foreach[U](f: (A) ⇒ U): Unit

23. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to StringFormat[GenIterable[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

24. #### def genericBuilder[B]: Builder[B, GenIterable[B]]

    The generic builder that builds instances of Traversable at arbitrary element types.

    The generic builder that builds instances of Traversable at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

25. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

26. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

27. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

28. #### abstract def map[B](f: (A) ⇒ B): Traversable[B]

    [use case] Builds a new collection by applying a function to all elements of this collection.

    [use case]

    Builds a new collection by applying a function to all elements of this collection.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection resulting from applying the given function `f` to each element of this collection and collecting the results.

    Definition Classes
      GenTraversableLike
    Full Signature

    #### abstract def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[GenIterable[A], B, That]): That

29. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this collection.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def max[A1 >: A](implicit ord: Ordering[A1]): A

30. #### abstract def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this collection with the largest value measured by function f.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

31. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this collection

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def min[A1 >: A](implicit ord: Ordering[A1]): A

32. #### abstract def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this collection with the smallest value measured by function f.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

33. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

34. #### def newBuilder: Builder[A, GenIterable[A]]

    The builder that builds instances of type Traversable[A]

    The builder that builds instances of type Traversable[A]

    Attributes
      protected[this]
    Definition Classes
      GenericTraversableTemplate → HasNewBuilder

35. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

36. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

37. #### def par: ParIterable[A]

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      Parallelizable

38. #### abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements in this collection of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the collection and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def product[A1 >: A](implicit num: Numeric[A1]): A1

39. #### abstract def sameElements(that: GenIterable[A]): Boolean

    [use case] Checks if the other iterable collection contains the same elements in the same order as this collection.

    [use case]

    Checks if the other iterable collection contains the same elements in the same order as this collection.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Note: will not terminate for infinite-sized collections.

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Definition Classes
      GenIterableLike
    Full Signature

    #### abstract def sameElements[A1 >: A](that: GenIterable[A1]): Boolean

40. #### abstract def sum: A

    [use case] Sums up the elements of this collection.

    [use case]

    Sums up the elements of this collection.

    returns

      the sum of all elements in this collection of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the collection and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def sum[A1 >: A](implicit num: Numeric[A1]): A1

41. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

42. #### abstract def to[Col[_]]: Col[A]

    [use case] Converts this collection into another by copying all elements.

    [use case]

    Converts this collection into another by copying all elements.

    Note: will not terminate for infinite-sized collections.

    Col

      The collection type to build.

    returns

      a new collection containing all elements of this collection.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

43. #### abstract def toArray: Array[A]

    [use case] Converts this collection to an array.

    [use case]

    Converts this collection to an array.

    Note: will not terminate for infinite-sized collections.

    returns

      an array containing all elements of this collection. An `ClassTag` must be available for the element type of this collection.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def toArray[A1 >: A](implicit arg0: ClassTag[A1]): Array[A1]

44. #### abstract def toMap[T, U]: Map[T, U]

    [use case] Converts this collection to a map.

    [use case]

    Converts this collection to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this collection.

    Definition Classes
      GenTraversableOnce
    Full Signature

    #### abstract def toMap[K, V](implicit ev: <:<[A, (K, V)]): GenMap[K, V]

45. #### def toParArray: ParArray[T]

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to CollectionsHaveToParArray[GenIterable[A], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (GenIterable[A]) ⇒ GenTraversableOnce[T] is in scope.
    Definition Classes
      CollectionsHaveToParArray

46. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

47. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): GenIterable[GenIterable[B]]

    Transposes this collection of traversable collections into a collection of collections.

    Transposes this collection of traversable collections into a collection of collections.

    The resulting collection's type will be guided by the static type of collection. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(4, 5, 6)).transpose
        // xs == List(
        //         List(1, 4),
        //         List(2, 5),
        //         List(3, 6))

        val ys = Vector(
                   List(1, 2, 3),
                   List(4, 5, 6)).transpose
        // ys == Vector(
        //         Vector(1, 4),
        //         Vector(2, 5),
        //         Vector(3, 6))

    B

      the type of the elements of each traversable collection.

    asTraversable

      an implicit conversion which asserts that the element type of this collection is a `Traversable`.

    returns

      a two-dimensional collection of collections which has as nth row the nth column of this collection.

    Definition Classes
      GenericTraversableTemplate
    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

    Exceptions thrown

      `IllegalArgumentException` if all collections in this collection are not of the same size.

48. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (GenIterable[A1], GenIterable[A2])

    Converts this collection of pairs into two collections of the first and second half of each pair.

    Converts this collection of pairs into two collections of the first and second half of each pair.

        val xs = Traversable(
                   (1, "one"),
                   (2, "two"),
                   (3, "three")).unzip
        // xs == (Traversable(1, 2, 3),
        //        Traversable(one, two, three))

    A1

      the type of the first half of the element pairs

    A2

      the type of the second half of the element pairs

    asPair

      an implicit conversion which asserts that the element type of this collection is a pair.

    returns

      a pair of collections, containing the first, respectively second half of each element pair of this collection.

    Definition Classes
      GenericTraversableTemplate

49. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (GenIterable[A1], GenIterable[A2], GenIterable[A3])

    Converts this collection of triples into three collections of the first, second, and third element of each triple.

    Converts this collection of triples into three collections of the first, second, and third element of each triple.

        val xs = Traversable(
                   (1, "one", '1'),
                   (2, "two", '2'),
                   (3, "three", '3')).unzip3
        // xs == (Traversable(1, 2, 3),
        //        Traversable(one, two, three),
        //        Traversable(1, 2, 3))

    A1

      the type of the first member of the element triples

    A2

      the type of the second member of the element triples

    A3

      the type of the third member of the element triples

    asTriple

      an implicit conversion which asserts that the element type of this collection is a triple.

    returns

      a triple of collections, containing the first, second, respectively third member of each element triple of this collection.

    Definition Classes
      GenericTraversableTemplate

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### abstract def zip[B](that: GenIterable[B]): Traversable[(A, B)]

    [use case] Returns a collection formed from this collection and another iterable collection by combining corresponding elements in pairs.

    [use case]

    Returns a collection formed from this collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    B

      the type of the second half of the returned pairs

    that

      The iterable providing the second half of each result pair

    returns

      a new collection containing pairs consisting of corresponding elements of this collection and `that`. The length of the returned collection is the minimum of the lengths of this collection and `that`.

    Definition Classes
      GenIterableLike
    Full Signature

    #### abstract def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[GenIterable[A], (A1, B), That]): That

54. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): Traversable[(A, B)]

    [use case] Returns a collection formed from this collection and another iterable collection by combining corresponding elements in pairs.

    [use case]

    Returns a collection formed from this collection and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    B

      the type of the second half of the returned pairs

    that

      The iterable providing the second half of each result pair

    thisElem

      the element to be used to fill up the result if this collection is shorter than `that`.

    thatElem

      the element to be used to fill up the result if `that` is shorter than this collection.

    returns

      a new collection containing pairs consisting of corresponding elements of this collection and `that`. The length of the returned collection is the maximum of the lengths of this collection and `that`. If this collection is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this collection, `thatElem` values are used to pad the result.

    Definition Classes
      GenIterableLike
    Full Signature

    #### abstract def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[GenIterable[A], (A1, B), That]): That

55. #### abstract def zipWithIndex: Traversable[(A, Int)]

    [use case] Zips this collection with its indices.

    [use case]

    Zips this collection with its indices.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    returns

      A new collection containing pairs consisting of all elements of this collection paired with their index. Indices start at `0`.

    Definition Classes
      GenIterableLike
    Full Signature

    #### abstract def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[GenIterable[A], (A1, Int), That]): That

    Example:

    1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

56. #### def →[B](y: B): (GenIterable[A], B)

    Implicit information
      This member is added by an implicit conversion from GenIterable[A] to ArrowAssoc[GenIterable[A]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, GenIterable]

### Inherited from HasNewBuilder[A, scala.collection.GenIterable[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from GenIterableLike[A, GenIterable[A]]

### Inherited from GenTraversableLike[A, GenIterable[A]]

### Inherited from Parallelizable[A, ParIterable[A]]

### Inherited from GenTraversableOnce[A]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from GenIterable[A] to CollectionsHaveToParArray[GenIterable[A], T]

### Inherited by implicit conversion any2stringadd from GenIterable[A] to any2stringadd[GenIterable[A]]

### Inherited by implicit conversion StringFormat from GenIterable[A] to StringFormat[GenIterable[A]]

### Inherited by implicit conversion Ensuring from GenIterable[A] to Ensuring[GenIterable[A]]

### Inherited by implicit conversion ArrowAssoc from GenIterable[A] to ArrowAssoc[GenIterable[A]]

### Ungrouped